<template>
  <Popup :conf="popupConfig">
    <div id="loginFormContainer">
      <h2>Authentication</h2>
      <div>
        <label>Username:</label>
        <input type="text" v-model="username" />
        <label>Password:</label>
        <input type="password" v-model="password" />
        <button @click="login">Login</button>
      </div>
    </div>
  </Popup>
</template>

<script>
import Popup from "./Popup.vue";
import PopupConfig from "./PopupConfig";
import FetchApi from "../util/FetchApi";
import Auth from "../util/Auth";

export default {
  name: "Login",
  data() {
    return {
      username: null,
      password: null,
      popupConfig: PopupConfig.POPUP_CONF_BLANK_300_300,
    };
  },
  methods: {
    async login() {
      const credentials = {
        username: this.username || "",
        password: this.password || "",
      };
      if (
        credentials.username.trim().length > 0 &&
        credentials.password.trim().length > 0
      ) {
        try {
          const session = await FetchApi.login(credentials);
          Auth.storeAuthentication(session);
          this.$router.push({ name: "Listed Companies" });
        } catch (e) {
          console.log("Login failed", e);
        }
      }
    },
  },
  components: {
    Popup,
  },
};
</script>